#
# Copyright (c) 2014-2016, Juniper Networks, Inc.
# All rights reserved.
#
. /etc/master_info

transfer_and_cleanup_coredumps()
{
    file=$1
    regex=$2

    remotedir=/var/crash

    # Transfer coredump to RE
    rcp $file $MASTER_IP:$remotedir

    # Keep only a limited no. of coredumps around
    # compute the limit based on RE sysctl debug.ncores
    maxcores=$(rsh $MASTER_IP sysctl -n debug.ncores)
    [ -n "$maxcores" ]  || maxcores=5

    ncores=$(ls -l $regex | wc -l)
    [ $ncores -gt $maxcores ]  || return
    for corefile in $(ls -t $regex | tail -n +$((maxcores+1)))
    do
	    echo "cleaning up core -" $corefile
	    rm -f $corefile 2>/dev/null

	    file=$(basename $corefile)
	    # clean up remote core file on RE also
	    $(rsh $MASTER_IP rm -f $remotedir/$file 2>/dev/null)
    done
}

# Transfer the coredumps from FPC to RE, if not present in RE.
transfer_coredumps()
{
    remotedir=/var/crash
    regex=$1
    for corefile in $(ls $regex)
    do
           file=$(basename $corefile)
           present=$(rsh $MASTER_IP '[ -e '$remotedir/$file' ] && echo 1')
           if [ -z "$present" ]; then
               rcp $corefile $MASTER_IP:$remotedir
           fi
    done
}
