#!/bin/sh
### BEGIN INIT INFO
# Provides:          hostname
# Required-Start:
# Required-Stop:
# Default-Start:     S
# Default-Stop:
# Short-Description: Set hostname based on /etc/hostname
### END INIT INFO

. /etc/init.d/junos_functions
. /etc/master_info

# Update /etc/hostname with <re-hostname>-<fru-name>
# e.g. jackie-fpc2. The hostname is set based on this file
# The RE name is determined from RE using rsh.  The Fru name is obtained using
# the IP address and the RE /etc/hosts.junos file (which gets pulled down from
# RE during installation). If there are multiple names for an IP address, then
# use the late one.. e.g. higher fpc slots on Tiny overlap with FEBs
update_hostname_file()
{
    my_ip=`get_my_ip_address`
    [ -n "$my_ip" ] && my_name=$(grep $my_ip /etc/hosts | tail -n 1 | awk '{print $NF}')
    if [ -n "$my_name" ]; then
            my_name=$(rsh $MASTER_IP sysctl -n kern.hostname)-$my_name
	    echo $my_name > /etc/hostname
    fi
}

HOSTNAME=$(/bin/hostname)

update_hostname_file

hostname -b -F /etc/hostname 2> /dev/null
if [ $? -eq 0 ]; then
	exit
fi

# Busybox hostname doesn't support -b so we need implement it on our own
if [ -f /etc/hostname ];then
	hostname -F /etc/hostname
elif [ -z "$HOSTNAME" -o "$HOSTNAME" = "(none)" -o ! -z "`echo $HOSTNAME | sed -n '/^[0-9]*\.[0-9].*/p'`" ] ; then
	hostname localhost
fi
